;     
; :
; -     
; -    
; -    
; - 

.include "tn15def.inc"

.def	B	= r16	;  ,
.def	A	= r17	;       
.def	Flags	= r18	;  
.def	VL	= r24	;  
.def	VH	= r25	;
.def	Time	= r26	;   

;   
.equ	i_Prg		= 0
.equ	o_LED		= 0
.equ	o_PWM		= 1
.equ	i_Pls		= 2
.equ	i_ADC		= 3
.equ	o_Brk		= 4

; 
.equ	f_ENB		= 0

.equ	TimeOut		= 50	;    ( -50...120)
.equ	BrakeTime	= 240	;   
.equ	VTH		= 315	;  
.equ	IdleTime	= 210	;  
.equ	DnTime		= 5	;  
.equ    BrkTime		= 3	;  
.equ	UpTime		= 220	;  
.equ	MaxOut		= 249	;   


.macro	LED_OFF
	sbi	PORTB,o_LED
	.endm

.macro	LED_ON
	cbi	PORTB,o_LED
	.endm


.cseg
.org	0
	rjmp	RESET
	rjmp	PULSE	; External Interrupt Request 0
	reti		; Pin Change Interrupt
	reti		; Timer/Counter1 Compare Match A
	reti		; Timer/Counter1 Overflow
	rjmp	TIMER	; Timer/Counter0 Overflow
	reti		; EEPROM Ready
	reti		; Analog Comparator
	rjmp	ADCI	; ADC Conversion Complete

RESET:
	;  
	ldi	A,0x20	;    ( -015....080)
	out	OSCCAL,A
	;  MCU   
	ldi	A,(1<<PUD)|(1<<ISC01)|(1<<ISC00)
	out	MCUCR,A
	ldi	A,(1<<INT0)
	out	GIMSK,A
	;  
	ldi	A,(1<<ACD)
	out	ACSR,A
	;  
	ldi	A,(1<<o_PWM)|(1<<o_Brk)|(1<<o_LED)
	out	DDRB,A
	ldi	A,(1<<o_PWM)|(0<<o_Brk)|(0<<o_LED)
	out	PORTB,A
	;  
	ldi	A,(0<<REFS1)|(0<<REFS0)|(0<<ADLAR)|(0<<MUX2)|(1<<MUX1)|(0<<MUX0)
	out	ADMUX,A
	ldi	A,(1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(1<<ADIE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)
	out	ADCSR,A
	;  0
	ldi	A,(1<<CS02)|(0<<CS01)|(1<<CS00)	; /1024
	out	TCCR0,A
	ldi	A,TimeOut
	out	TCNT0,A
	ldi	A,(1<<TOIE0)
	out	TIMSK,A
	;  1 - PWM 6400...18000 , , ..  
	ldi	A,MaxOut
	out	OCR1B,A
	ldi	A,0
	out	OCR1A,A
	ldi	A,(1<<PWM1)|(1<<COM1A1)|(1<<COM1A0)|(0<<CS13)|(1<<CS12)|(0<<CS11)|(1<<CS10)
	out	TCCR1,A

	ldi	Flags,0	;  

	sei
MAIN:
	rjmp	MAIN

PULSE:
	ldi	A,TimeOut	;    
	out	TCNT0,A		;  

	ldi	Time,IdleTime
P0:				;   
	nop			; 1
	nop			; 1
	nop			; 1
	nop			; 1
	nop			; 1
	dec	Time		; 1
	brne	P0		; 2
P1:				;	  
	inc	Time		; 1
	cpi	Time,UpTime	; 1      
	brsh	P3		; 1\2     
	nop			; 1
	sbic	PINB,i_Pls	; 1
	rjmp	P1		; 2

	cpi	Time,DnTime		;   
	brsh	P2			;   
	sbr	Flags,(1<<f_ENB)	;  ,  
	LED_OFF
P2:
	sbrs	Flags,f_ENB		;  
	ldi	Time,0			; .
P4:
	rcall	RUN			;  
	reti
P3:
	ldi	Time,MaxOut		; . 
	rjmp	P2

ADCI:
	in	VL,ADCL
	in	VH,ADCH
	ldi	A,low(VTH)
	ldi	B,high(VTH)
	cp	VL,A
	cpc	VH,B
	brsh	ADCEX			;  V < TH, 
	sbrs	Flags,f_ENB
	reti
TIMER:
	ldi	A,BrakeTime
	out	TCNT0,A
	cbr	Flags,(1<<f_ENB)	; 
	LED_ON				;
	tst	Time
	breq	T1
	dec	Time			;  
T1:
	rcall	RUN
ADCEX:
	reti

RUN:
	cpi	Time,BrkTime
	brsh	R1
	in	A,TCCR1
	cbr	A,(1<<COM1A1)|(1<<COM1A0)
	out	TCCR1,A
	sbi	PORTB,o_PWM		;  
	sbi	PORTB,o_Brk		; 
	ret
R1:
	cpi	Time,BrkTime+4		;  
	brlo	R2
	cbi	PORTB,o_Brk		;  
	in	A,TCCR1
	sbr	A,(1<<COM1A1)|(1<<COM1A0)
	out	TCCR1,A			;  
	out	OCR1A,Time		;  
R2:
	ret
